-- K Mod
-- Author:	Ifko[nator]
-- Datum:	02.01.2015

FruitUtil.registerFruitType("compostSolid", false, false, true, 1, 100, 2, 1, 1, nil);

FruitUtil.registerFruitTypeWindrow(FruitUtil.FRUITTYPE_COMPOSTSOLID, "compostSolid_windrow", g_i18n:getText("compostSolid"), 0, 3, false, nil);

local orgi_sprayerUpdateTick = Sprayer.updateTick
Sprayer.updateTick = function(self, dt)
	orgi_sprayerUpdateTick(self, dt)
	if self.isTurnedOn and self.fillLevel > 0 then
		local windrowId = nil;
		
		if self.currentFillType == Fillable.FILLTYPE_COMPOST_SOIL then
			if g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID] then
				windrowId = g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID].windrowId;
			end;
		end;

		if windrowId ~= nil then
			for _, workArea in pairs(self.workAreas) do
				if self:getIsAreaActive(workArea) then
					local x, y, z = getWorldTranslation(workArea.start);
					local x1, y1, z1 = getWorldTranslation(workArea.width);
					local x2, y2, z2 = getWorldTranslation(workArea.height);
					if self.FeldBegrenzung ~= nil then
						Utils.updateManureWindrowArea(windrowId, x, z, x1, z1, x2, z2, not self.FeldBegrenzung);
					else
						Utils.updateManureWindrowArea(windrowId, x, z, x1, z1, x2, z2);
					end;
				end;
			end;                                                                                                                                                                         
		end;
	end;
end;

Utils.updateManureWindrowArea = function(windrowId, x, z, x1, z1, x2, z2)
	local IDs,detailId = {}, g_currentMission.terrainDetailId;                                                                                                                           
	local dx, dz, dwidthX, dwidthZ, dheightX, dheightZ = Utils.getXZWidthAndHeight(detailId, x, z, x1, z1, x2, z2);                                                                      

	setDensityParallelogram(windrowId, dx, dz, dwidthX, dwidthZ, dheightX, dheightZ, 0, g_currentMission.numWindrowChannels, g_currentMission.maxWindrowValue);
end;                                                                                                                                                                                     

Utils.DestroyManureWindrowArea = function(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)                                                                
	if g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID] ~= nil then
		Utils.updateDensity(g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID].windrowId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, 0, 0);
	end;                                                                                                                                                         
end;                                                                                                                                                                                     

local orgi_UpdateDestroyCommonArea = Utils.updateDestroyCommonArea;
Utils.updateDestroyCommonArea = function(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, limitToField)
	orgi_UpdateDestroyCommonArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, limitToField);

	if g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID] ~= nil then
		Utils.updateDensity(g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID].windrowId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, 0, 0);
	end;
end;                                                                                                                                                                                     

local orgi_cutFruitArea = Utils.cutFruitArea;                                                                                                                                            
Utils.cutFruitArea =  function(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, destroySpray, destroySeedingWidth)
	local pixelsSum, numPixels, spraySum = orgi_cutFruitArea(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, destroySpray, destroySeedingWidth);
	if destroySpray then
		if g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID] ~= nil then
			Utils.updateDensity(g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID].windrowId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, 0, 0);
		end;
	end;
	return pixelsSum, numPixels, spraySum;
end;                                                                                                                                                                                     

local orgi_updateSowingArea = Utils.updateSowingArea;
Utils.updateSowingArea = function(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, useDirectPlanting)
	local numPixels, numDetailPixels = orgi_updateSowingArea(fruitId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, angle, useDirectPlanting);
	
	if g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID] ~= nil then
		Utils.updateDensity(g_currentMission.fruits[FruitUtil.FRUITTYPE_COMPOSTSOLID].windrowId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, 0, 0);
	end;
	return numPixels, numDetailPixels;
end;